
Foreman - Bug #6375

Can't create parameters for operating system with id 1 using API

06/25/2014 09:20 AM - Marek Hulán

Status: Closed   

Priority: Normal   

Assignee: Joseph Magen   

Category: API   

Target version: 1.5.2   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: Nightly

Bugzilla link: 1114640 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/1567

  

Description

When you try to create a new parameter for operating system with id 1, you result in 422 error

Started POST "/api/operatingsystems/1/parameters" for 192.168.122.22 at 2014-06-25 08:46:15 +0000

Processing by Api::V2::ParametersController#create as JSON

  Parameters: {"parameter"=>{"value"=>"[FILTERED]", "name"=>"ssh_public_key"}, "apiv"=>"v2", "oper

atingsystem_id"=>"1"}

Authorized user admin(Admin User)

Unprocessable entity OsParameter (id: new):

  Reference parameters require an associated domain, host or host group

  Rendered api/v2/errors/unprocessable_entity.json.rabl within api/v2/layouts/error_layout (1.3ms)

Completed 422 Unprocessable Entity in 657ms (Views: 2.4ms | ActiveRecord: 299.7ms)

 The issue is in that reference_id is set to nil (this is inspect of @parameter from create action)

#<OsParameter id: nil, name: "ssh_public_key", value: "ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAQEA5mX2JV6

T6CVCRmT...", reference_id: nil, created_at: nil, updated_at: nil, type: "OsParameter", priority: 

2>

 git bisect found #5129 and 691f0a1a809569d125e9385e60f8f1e1c8d88061 as a source of the issue. It seems that for some reason

we enforce nil for reference_id when it's set to 1. Related PR https://github.com/theforeman/foreman/pull/1504. Note that it was

merged to 1.5.2

Related issues:

Related to Foreman - Bug #5129: Host Group creation may fail if Host Group wi... Closed 04/09/2014

Related to Foreman - Refactor #14934: Remove Rails 3.2.8 workaround in parame... Closed 05/05/2016

Associated revisions

Revision 5dded917 - 07/22/2014 03:49 AM - Joseph Magen

fixes #6375 - fix needed for Rails 3.2.8 only that ensures reference_id on parameter.rb matches the nested object id

Revision 37af54e1 - 07/28/2014 07:28 AM - Joseph Magen

fixes #6375 - fix needed for Rails 3.2.8 only that ensures reference_id on parameter.rb matches the nested object id

(cherry picked from commit 5dded9172adeadb8ef0f56a33787b213784551a4)

Revision 1d939ec0 - 07/28/2014 09:13 AM - Dominic Cleal

refs #6375 - revert string change

History

#1 - 06/25/2014 09:21 AM - Marek Hulán

- Subject changed from Can't create parameters for operating systems using API to Can't create parameters for operating system with id 1 using API
https://projects.theforeman.org/issues/5129
http://projects.theforeman.org/projects/foreman/repository/revisions/691f0a1a809569d125e9385e60f8f1e1c8d88061
https://github.com/theforeman/foreman/pull/1504


- Description updated

#2 - 06/25/2014 09:25 AM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Joseph Magen

- Target version set to 1.8.1

- translation missing: en.field_release set to 18

Thanks, that should've been obvious...

#3 - 06/30/2014 10:21 AM - Bryan Kearney

- Bugzilla link set to 1114640

#4 - 07/07/2014 07:25 AM - Anonymous

- Target version changed from 1.8.1 to 1.8.0

#5 - 07/07/2014 10:16 AM - Joseph Magen

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/1567

#6 - 07/21/2014 11:24 AM - Dominic Cleal

- Related to Bug #5129: Host Group creation may fail if Host Group with id 1 exists with same parameter name added

#7 - 07/22/2014 04:01 AM - Joseph Magen

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 5dded9172adeadb8ef0f56a33787b213784551a4.

#8 - 07/22/2014 05:31 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/1567 added

#9 - 05/05/2016 06:32 AM - Tomer Brisker

- Related to Refactor #14934: Remove Rails 3.2.8 workaround in parameter model added
